import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Parabola here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Parabola extends Actor
{
    private Dot[] dots;
    /**
     * Act - do whatever the Parabola wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        // Add your action code here.
    }  
    
    public Parabola()
    {
        dots = new Dot[3];
    }
    
    public void addedToWorld(World world)
    {
        setImage(new GreenfootImage(world.getWidth(), world.getHeight()));
        for (int i = 0; i < 3; i++) {
            dots[i] = new Dot(this);
            world.addObject(dots[i],Greenfoot.getRandomNumber(world.getWidth()),Greenfoot.getRandomNumber(world.getHeight()));
        }
        update();
    }
    
    public void update()
    {
        GreenfootImage image = getImage();
        image.clear();
        double a = -(x(1)*y(2) - x(1)*y(3) - x(2)*y(1) + x(2)*y(3) + x(3)*y(1) - x(3)*y(2))/( (x(1)-x(3))*(x(1)-x(2))*(x(2)-x(3)) );
        double b = (x(1)*x(1)*y(2) - x(1)*x(1)*y(3) - x(2)*x(2)*y(1) + x(2)*x(2)*y(3) + x(3)*x(3)*y(1) - x(3)*x(3)*y(2))/( (x(2)-x(3))*(x(1)-x(2))*(x(1)-x(3)) );
        double c = (x(1)*x(1)*x(2)*y(3) - x(1)*x(1)*x(3)*y(2) - x(1)*x(2)*x(2)*y(3) + x(1)*x(3)*x(3)*y(2) + x(2)*x(2)*x(3)*y(1) - x(2)*x(3)*x(3)*y(1))/( (x(1)-x(3))*(x(1)-x(2))*(x(2)-x(3)) );
        int temp = (int)c;
        for (int x = 1; x < getWorld().getWidth(); x++) {
            int y = (int)(a*x*x + b*x + c);
            image.drawLine(x-1,temp,x,y);
            temp = y;
        }
    }
    
    public Dot[] getDots()
    {
        return dots;
    }
    
    private double x(int dot)
    {
        return dots[dot-1].getX();
    }
    
    private double y(int dot)
    {
        return dots[dot-1].getY();
    }
}
