import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Dot here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Dot extends Actor
{
    private Parabola parabola;
    private int tempX;
    private int tempY;
    /**
     * Act - do whatever the Dot wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        MouseInfo mouse = Greenfoot.getMouseInfo();
        if (mouse == null) {
            return;
        }
        if (Greenfoot.mousePressed(this)) {
            tempX = getX() - mouse.getX();
            tempY = getY() - mouse.getY();
        }
        if (Greenfoot.mouseDragged(this)) {
            setLocation(mouse.getX()+tempX,mouse.getY()+tempY);
            parabola.update();
        }
    }    

    public Dot(Parabola parabola)
    {
        this.parabola = parabola;
        GreenfootImage image = new GreenfootImage(11,11);
        image.setColor(java.awt.Color.blue);
        image.fillOval(0,0,image.getWidth(),image.getHeight());
        setImage(image);
    }
    
    public void setLocation(int x, int y)
    {
        Dot[] dots = parabola.getDots();
        for (int i = 0; i < 3; i++) {
            Dot dot = dots[i];
            if (dot != null) {
                if (x == dot.getX() && this != dot) {
                    setLocation(x-1,y);
                    return;
                }
            }
        }
        super.setLocation(x,y);
    }
}
